#include <stdio.h>
#include <fstream.h>
#include <strstream.h>
#include "client.h"
#include "rpc.h"
#include "error.h"


extern FILE* yyin;
ofstream fout;
char* schema_include_file;
int ldb_sm_location;

void parse_odl ();

static LDB* ldb;

error_stream eout;


void process_definition ( const char* definition ) {
  ldb->process_definition(definition);
};


int main ( int argc, char* argv[] ) {
  if (argc != 2) {
     cerr << "Wrong number of parameters\n";
     exit(1);
  };
  int len = strlen(argv[1]);
  if (len>4 && argv[1][len-4] == '.' && argv[1][len-3] == 'o'
      && argv[1][len-2] == 'd' && argv[1][len-1] == 'l')
  {   yyin = fopen(argv[1],"r");
      ldb = new LDB;
      try {
	ldb->open("");
	ldb->begin_transaction();
	parse_odl();
	ldb->commit_transaction();
	ldb->close();
      } catch (ServerError(m)) {
	cerr << m;
	ldb->close();
      };
  } else cerr << "Input file must be an .odl file\n";
};
