/*********************************************************************************
 *
 *  The ODMG ODL compiler
 *  Copyright (c) 1999-2003 by Leonidas Fegaras, the University of Texas at
 *     Arlington, All rights reserved.
 *  Programmer: Leonidas Fegaras
 *  Date: 9/28/98, 1/6/02
 *
 ********************************************************************************/

#include <sys/stat.h>
#include <stream.h>
#include <fstream.h>
#include <string.h>
#include <signal.h>
#include <sm_vas.h>
#include "odl.h"
#include "odmg_main.h"


extern FILE *yyin;

void parse_odl ();

void abort_odl ( int n ) {
  if (n==SIGFPE)
    cerr << "*** Floating point exception error.\n";
  else cerr << "*** Fatal System Error.\n";
  w_base_t::abort();
};


void MAIN ( int argc, char* argv[] ) {
  char* ifile = new (GC) char[40];
  strcpy(ifile," ");
  signal(SIGINT,abort_odl);
  signal(SIGQUIT,abort_odl);
  signal(SIGSEGV,abort_odl);
  signal(SIGFPE,abort_odl);
  if (argc != 2)
     SM_ERROR("Wrong number of parameters");
  int len = strlen(argv[1]);
  if (len>4 && argv[1][len-4] == '.' && argv[1][len-3] == 'o'
     && argv[1][len-2] == 'd' && argv[1][len-1] == 'l')
  {   strcpy(ifile,argv[1]);
      yyin = fopen(ifile,"r");
      char* ofile = new (GC) char[len+1];
      schema_include_file = ofile;
      strcpy(ofile,argv[1]);
      ofile[len-3] = 'h';
      ofile[len-2] = '\0';
      fout.open(ofile);
      try {
	ldb_sm->begin_transaction();
	login(sm_string("admin"),sm_string("pass"));
	parse_odl();
	ldb_sm->commit_transaction();
      } catch (odmg_error_class(m)) {
	cerr << m.message;
	w_base_t::abort();
      };
  } else SM_ERROR("Input file must be an .odl file");
};
