/********************************************************************************
*
* This file must be included in the beginning of any *.oql file
*
* Copyright (c) 1999-2003 by Leonidas Fegaras, the University of Texas at
*     Arlington. All rights reserved.
* Programmer: Leonidas Fegaras, UTA
* Date: 12/6/98
*
*********************************************************************************/

#ifndef __odmg_h__
#define __odmg_h__

#include <stream.h>
#include "odl.h"
#include "eval.h"

static void* _scoped_variables[1000];
static int current_scoped_variable_number = 100;

static void** _scope = new (GC) void*[10000];
static int _scope_top = 0;
static int _scope_size = 0;

void collect_statistics ();

void* compile_query ( const char* query );

void* evaluate_plan ( void* plan );

void print_value ( const char* type, void* value, short max_depth);

void store_struct_name ( const char* type, const char* name );

class plan: public gc {
private:
  void* plan_code;
  void* plan_type;
public:
  plan ( const char* query, short level );
  plan ( const char* stmt );
  void* get_type () { return plan_type; };
  void* evaluate ();
  void print_type ();
  void print_value ( void* value, short max_depth );
};


static void _new_scope ( int n ) {
  _scope += n;
};

template<class T>
static T _return_from_scope ( int n, T v ) {
  _scope -= n;
  return v;
};

#endif
