#!/bin/sh
# the next line restarts using tclsh \
exec tclsh "$0" "$@"
#--------------------------------------------------------------------------------
#
# Tcl script for the OQL interpreter.
# Programmer: Leonidas Fegaras
# Creation: 02/12/03
# Copyright (c) 2003 by Leonidas Fegaras, the University of Texas at
#     Arlington. All rights reserved.
#
#--------------------------------------------------------------------------------


source "[file dirname $argv0]/rpc.tcl"


proc login {} {
    puts -nonewline "Username: "
    flush stdout
    set username [gets stdin]
    puts -nonewline "Password: "
    flush stdout
    set password [gets stdin]
    puts -nonewline "Schema Name: "
    flush stdout
    set schema [gets stdin]
    open $username $password $schema
}


proc main {} {
    global argv
    puts "The LDB OQL interpreter. Must have a server running."
    # login
    set schema [lindex $argv 0]
    if {$schema == ""} {
	puts -nonewline "Schema Name: "
	flush stdout
	set schema [gets stdin]
    }
    open admin pass $schema
    puts "Type an OQL query or 'quit' to exit."
    set query ""
    while {$query != "quit"} {
	puts -nonewline "> "
	flush stdout
	set query [gets stdin]
	if {$query != "quit" && $query != ""} {
	    begin
	    catch {
		set obj [query $query]
		puts "(:$obj)   [getType $obj]"
		puts [toString $obj]
	    } errormsg
	    if {[lindex $errormsg 0] != 0} {
		puts -nonewline $errormsg
	    }
	    commit
	}
    }
    close
}


main
