/*********************************************************************************
 *
 *  Parsing and optimizing ODMG OQL
 *  Copyright (c) 1999-2003 by Leonidas Fegaras, the University of Texas at
 *     Arlington, All rights reserved.
 *  Programmer: Leonidas Fegaras
 *  Date: 10/1/98
 *
 ********************************************************************************/

#include <sys/stat.h>
#include <stdlib.h>
#include "odl.h"
#include "odmg_main.h"
#include <signal.h>

char* mfile;

extern FILE *yyin;

extern int parser_line;

extern int parser_column;

void odmg_error (const char* s);

void parse_oql();


void abort_oql ( int n ) {
  if (n==SIGFPE)
    cerr << "*** Floating point exception error.\n";
  else cerr << "*** Fatal System Error.\n";
  w_base_t::abort();
};


void MAIN ( int argc, char* argv[] ) {
  signal(SIGINT,abort_oql);
  signal(SIGQUIT,abort_oql);
  signal(SIGSEGV,abort_oql);
  signal(SIGFPE,abort_oql);
  char* ifile = new (GC) char[40];
  strcpy(ifile," ");
  if (argc==2)
  {  int len = strlen(argv[1]);
     if (len>4 && argv[1][len-4] == '.' && argv[1][len-3] == 'o'
        && argv[1][len-2] == 'q' && argv[1][len-1] == 'l')
     { strcpy(ifile,argv[1]);
       yyin = fopen(ifile,"r");
       mfile = new (GC) char[len+8];
       strcpy(mfile,argv[1]);
       strcpy(mfile+len-3,"tmp.cc");
       mout.open(mfile);
       mout << "#line 1 \"" << ifile << "\"\n";
       ffile = new (GC) char[len+8];
       strcpy(ffile,argv[1]);
       strcpy(ffile+len-3,"tmp.h");
       fout.open(ffile);
     } else {  cerr << "Input file must be an .oql file\n";
               exit(0);
            };
     try {
       ldb_sm->begin_transaction();
       login(sm_string("admin"),sm_string("pass"));
       initialize_current_module();
       parse_oql();
       ldb_sm->commit_transaction();
     } catch (odmg_error_class(m)) {
       cerr << m.message;
       w_base_t::abort();
     };
     fout.close();
     mout.close();
  }
  else SM_ERROR("The OQL parser needs only one parameter (the .oql file)");
};
