/*********************************************************************************
 *
 *  Typechecking OQL algebraic forms (monoid comprehensions)
 *
 *  Copyright (c) 1999-2003 by Leonidas Fegaras, the University of Texas at
 *     Arlington. All rights reserved.
 *  Programmer: Leonidas Fegaras
 *  Date: 10/10/98
 *
 ********************************************************************************/


typedef binding<Expr>* Schema;
typedef list<pair<Expr,Expr>*>* GEnv;

bool is_class ( Expr type );

Expr typecheck ( Expr e, Schema &cvars, Schema &lvars, GEnv &gvars );

Expr type_of ( Expr &e, Schema vars, bool first_time = false, bool type_varsp = false );

Expr type_of ( Expr &e );

bool unify ( Expr e, Expr x, Expr y, Schema &lvars, bool subtype = false );

Schema type_to_schema ( Expr tp );

Expr get_scoped_type ( Expr type );

int last_scoped_var();

Expr find_scoped_variable ( String s );

int scoped_variable_location ( String s );

void put_in_current_scope ( String name, Expr type );

bool collectionp ( Expr x );

void type_error ( string msg, Expr e);

/* find an internal method for method_name that matches the type signature method_types */
pair<Expr,int>* find_internal_method ( String method_name, list<Expr>* method_types, Schema &lvars );


/* returns a new type variable that hasn't been used before; it starts as
   commutative-idempotent (equivalent to a set) but later (during unification) may be refined */
Expr fresh_type_variable ();

Expr eliminate_type_vars ( Expr x, Schema lvars, bool first_time, bool type_varsp );

void new_scope ( void );
void close_scope ( void );
int set_scope ( int );
