/*********************************************************************************
 *
 *  The server storage manager code. It uses the SHORE SM layer.
 *  Copyright (c) 2002, 2003 by Leonidas Fegaras, the University of Texas at
 *     Arlington. All rights reserved.
 *  Programmer: Leonidas Fegaras
 *  Date: 1/10/02
 *
 ********************************************************************************/

#ifdef LDB_SERVER


class startup_smthread_t : public smthread_t {
public:
   startup_smthread_t ();
   ~startup_smthread_t () {};
   void run ();
};


class transaction_smthread_t : public smthread_t {
public:
   transaction_smthread_t ();
   ~transaction_smthread_t () {};
   void run ();
};


class startup_thread_t : public smthread_t {
public:
   startup_thread_t ();
   ~startup_thread_t () {};
   void run ();
};


class cleanup_thread_t : public smthread_t {
public:
   cleanup_thread_t ();
   ~cleanup_thread_t () {};
   void run ();
};


typedef struct pin_cell {
   pin_i*    value;
   pin_cell* next;
} pin_cell;


class transaction_thread_t : public smthread_t {
public:
   int sock;
   struct sockaddr_in clientname;
   rpc_stream stream;
   pinned_object* current_object;  // set when dereferencing an object
   pinned_object* run_objects[100];
   int run_object_position;
   pin_cell* pins;
   bool active;
public:
   transaction_thread_t ();
   ~transaction_thread_t () {};
   static transaction_thread_t* me () { return (transaction_thread_t*) smthread_t::me(); };
   void run ();
};

#endif
