awk '
# Generation of RPC stubs from C++ function/method signatures
# Programmer: Leonidas Fegaras
# Date: 9/18/02
BEGIN { RC = -1
   printf "/* RPC stubs generated by the AWK script stubs.awk.\n"
   printf " * Do not edit this file. Edit the files *.x instead.  */\n\n"
}
/[A-Za-z]/ {
   RC++
   params = 0
   out_type = ""
   class = ""
   fnc = ""
   for(i=1; i<NF && params==0; i++) {
      if ($i=="(") {
         if (index($(i-1),"::")) {
            class = substr($(i-1),0,index($(i-1),"::")-1)
            fnc = substr($(i-1),index($(i-1),"::")+2)
         }
         else fnc = $(i-1)
         params = i+1
         break
      }
      else if(i>1)
         out_type = out_type " " $(i-1)
   }
   out_type = substr(out_type,2)
   j = 0
   type[0] = ""
   out[0] = 0
   for(i=params; i<NF; i++) {
      if ($(i+1)==");" || $(i+1)==")" || index($i,",")) {
         var[j] = $i
         if (substr(var[j],0,1)=="&") {
            var[j] = substr(var[j],2,length(var[j])-1)
            out[j] = 1;
         }
         if (index(var[j],","))
            var[j] = substr(var[j],0,index(var[j],",")-1)
         j++
         type[j] = ""
         out[j] = 0
      }
      else
         type[j] = type[j] " " $i
   }
   print "#ifndef LDB_SERVER"
   if (out_type!="")
      printf "%s ", out_type
   if (class=="")
      printf "%s (", fnc
   else
      printf "%s::%s (", class, fnc
   for(k=0; k<j; k++) {
      if (out[k]==1)
         printf "%s &%s", type[k], var[k]
      else printf "%s %s", type[k], var[k]
      if (k!=j-1)
         printf ","
   }
   if ($NF=="const;")
      printf " ) const {\n"
   else
      printf " ) {\n"
   if (class=="")
      printf "   if (STUBS_DEBUG) cout << \"%s( \"", fnc
   else if (class==fnc)
      printf "   if (STUBS_DEBUG) cout << \"%s::%s( ?\"", class, fnc
   else
      printf "   if (STUBS_DEBUG) cout << \"%s::%s( \" << this->ref", class, fnc
   for(k=0; k<j; k++)
      printf " << \", \" << %s", var[k]
   printf " << \" )\\n\";\n"
   if (out_type!="void" && out_type!="")
      printf "   %s _res;\n", out_type
   printf "   RPC_stream << (short) %d", RC
   if (class!="" && out_type!="")
      printf " << this->ref"
   printf ";\n"
   for(k=0; k<j; k++)
      if (out[k]==0)
         printf "   RPC_stream << %s;\n", var[k]
   if (out_type=="" && class==fnc)
      printf "   RPC_stream >> this->ref;\n"
   printf "   RPC_stream.rpc_validate();\n"
   for(k=0; k<j; k++)
      if (out[k]==1)
         printf "   RPC_stream >> %s;\n", var[k]
   if (class=="")
      printf "   if (STUBS_DEBUG) cout << \"-> %s\\n\";\n", fnc
   else
      printf "   if (STUBS_DEBUG) cout << \"-> %s::%s\\n\";\n", class, fnc
   if (out_type!="void" && out_type!="")
      printf "   return _res;\n"
   printf "};\n#else\nvoid RPC_%d ( rpc_stream stream ) {\n", RC
   if (class!="" && class!=fnc)
      printf "   int _obj;\n", class
   for(k=0; k<j; k++)
      if (substr(type[k],1,6)==" const")
         printf "   %s %s;\n", substr(type[k],8), var[k]
      else printf "  %s %s;\n", type[k], var[k]
   if (class!="" && class!=fnc)
      printf "   stream >> _obj;\n"
   for(k=0; k<j; k++)
      if (out[k]==0)
         printf "   stream >> %s;\n", var[k]
   if (class=="")
      printf "   if (STUBS_DEBUG) cout << \"%s( \"", fnc
   else if (class==fnc)
      printf "   if (STUBS_DEBUG) cout << \"%s::%s( ?\"", class, fnc
   else
      printf "   if (STUBS_DEBUG) cout << \"%s::%s( \" << _obj", class, fnc
   for(k=0; k<j; k++)
      if (out[k]==1)
         printf " << \", ? ,\""
      else printf " << \", \" << %s", var[k]
   printf " << \" )\\n\";\n"
   if (out_type=="" || out_type=="void")
      printf "   "
   else 
      printf "   %s _res = ", out_type
   if (class=="LDBobject" && class!=fnc)
      printf "(%s(_obj)).%s(", class, fnc
   else if (class!="" && class!=fnc)
      printf "((%s*) get_object(_obj))->%s(", class, fnc
   else if (out_type=="" && class==fnc)
      printf "store_object(new (GC) %s(", fnc
   else
      printf "%s(", fnc
   for(k=0; k<j; k++) {
      printf "%s", var[k]
      if (k!=j-1)
         printf ","
   }
   if (out_type=="" && class==fnc)
      printf ")"
   printf ");\n"
   printf "   stream.rpc_OK();\n"
   if (out_type!="void" && out_type!="")
      printf "   stream << _res;\n"
   for(k=0; k<j; k++)
      if (out[k]==1)
         printf "   stream << %s;\n", var[k]
   if (class=="")
      printf "   if (STUBS_DEBUG) cout << \"-> %s\\n\";\n", fnc
   else
      printf "   if (STUBS_DEBUG) cout << \"-> %s::%s\\n\";\n", class, fnc
   printf "};\n"
   printf "static int RPC_X_%d = (RPC_fnc_count = %d, dispatch_table[RPC_fnc_count] = &RPC_%d, 0);\n#endif\n\n", RC, RC, RC
}
' $*
